<?php

#------------------------------------------------------
# INFO
#------------------------------------------------------
# This is part of the Post Notification Plugin for 
# Wordpress. Please see the readme.txt for details.
#------------------------------------------------------

function post_notification_admin_sub(){
	global $wpdb;
	$t_posts = $wpdb->prefix . 'post_notification_posts';
	$datestr = get_settings('date_format') . ' ' . get_settings('time_format');
	
	//Check for problems
	$mutex = @fopen(ABSPATH . 'wp-content/plugins/post_notification/_temp/post_notification.lock', 'w');
	if($mutex == false){
		echo '<div class="error">' .  __('Couldn\'t create File:', 'post_notification') . ' wp-content/plugins/post_notification/_temp/post_notification.lock<br />'
			. __('Please assure the the path is writeable.', 'post_notification') .' '. __('It is also used for the captcha.', 'post_notification') . '</div>'	;
	} else {
		fclose($mutex);
	}
	
	
	
	if(!function_exists('iconv')){
		echo '<div class="error">' .  __('PHP was compiled without iconv-libs. This might cause severe trouble using UTF-8 with special chars or umlauts.', 'post_notification') . '</div>';
	}
	
	if(!function_exists('html_entity_decode')){
		echo '<div class="error">' .  __('This version of PHP does not support the function html_entity_decode. Sending out text mails will not be possible.', 'post_notification') . '</div>';
	}
	
	
	if('' != ($dest = post_notification_installtheme())){
		echo '<div class="error">' . __('Couldn\'t create File:', 'post_notification') . $dest . ' ';
		_e('Please assure the the path is writeable.', 'post_notification') . ' '; 
		_e('You can also copy the file from the plugin directory manually.', 'post_notification');
		echo '</div>';
	}
	
	if(!function_exists('mb_check_encoding')){
		echo '<div class="error">' . __('This version of PHP does not support the function mb_check_encoding. You might get some trouble with non-ASCII chars in the subject.', 'post_notification');
		echo '</div>';
	}
	
	//------------ Some info.....
	echo '<p>' . __('All dates are GMT.', 'post_notification') . ' '. __('The GMT-time is:', 'post_notification'); 
	echo ' <b>' . mysql2date($datestr, gmdate('Y-m-d H:i:s')) . '</b></p>'; //Can use i18n_time as it uses date
	
	echo '<p>' .  __('Posts to be notified.', 'post_notification');
	$posts = $wpdb->get_results(
	"SELECT id, post_title, post_date_gmt, notification_sent, post_status " 
		. post_notification_sql_posts_to_send() .
		" ORDER BY post_date_gmt DESC");
	echo '<table>
		<tr class="alternate"><th>'
			. __('Post-ID', 'post_notification') . '</th><th>'
			. __('Post title', 'post_notification') . '</th><th>'
			. __('Publish-date', 'post_notification') . '</th><th>'
			. __('Last email-id', 'post_notification') . '</th></tr>';
	
	foreach($posts as $post){
		echo  '<tr class="alternate"><td>'
			. $post->id . '</td><td>' 
			. $post->post_title . '</td><td>'
			. mysql2date($datestr, $post->post_date_gmt) . '</td><td>' 
			. $post->notification_sent . '</td></tr>';
	
	}
	echo '</table></p>';
	
	echo '<p>' . __('The next mail will be sent:', 'post_notification') . ' ';
	if(get_option('post_notification_nextsend') == '-1'){
		 _e('never', 'post_notification');
	} else {
		echo mysql2date($datestr, gmdate('Y-m-d H:i:s', get_option('post_notification_nextsend')));
	}
	echo '</p>';
	
	echo '<p>' . __('The last mail was sent:', 'post_notification') . ' ';
	echo mysql2date($datestr, gmdate('Y-m-d H:i:s', get_option('post_notification_lastsend')));
	echo '</p>';
	echo '<p>' . __('The last post was saved:', 'post_notification') . ' ';
	echo mysql2date($datestr, gmdate('Y-m-d H:i:s', get_option('post_notification_lastpost')));
	echo '</p>';

	
	
}
?>