<?php

/* All output is set up:
<h2>Header</h2>
<div class = "$class">
output
</div>
The default class ist "entry"

You can easily add this function to a template, use a page with this template and set that Page as default.
*/

function post_notification_check_captcha(){
	if(get_option('post_notification_captcha') == 0) return true;
	if($_POST['captchacode'] == '') return false;
	if($_POST['captcha'] == '') return false;
	require_once( 'class.captcha.php' );
	$my_captcha = new captcha($_POST['captchacode'], ABSPATH . 'wp-content/plugins/post_notification/_temp');
	return $my_captcha->verify( $_POST['captcha']);
}



function post_notification_fe($class = 'entry'){
	global $wpdb;
		
	// ******************************************************** //
	//                  GET VARIABLES FROM URL
	// ******************************************************** //
	$action=$_GET['action'];
	$addr=$_GET['addr'];
	
	if ($_POST['email']) {
		$action = $_POST['action'];
		$addr = $_POST['email'];
	}
	
	
	// ******************************************************** //
	//                  DEFINE OTHER VARS NEEDED
	// ******************************************************** //
	require_once(ABSPATH . 'wp-content/plugins/post_notification/' . get_option('post_notification_profile') . '/strings.php');
	
	
	$t_emails = $wpdb->prefix . 'post_notification_emails';
	
	
	$from_email = get_option('post_notification_from_email');
	$pnurl      = post_notification_get_link();
	if(get_option('post_notification_hdr_nl') == "rn")
		$hdr_nl = "\r\n";
	else
		$hdr_nl = "\n";
	$blogname     = get_option('blogname');
	
	
	
	// ******************************************************** //
	//                      SUBSCRIBE
	// ******************************************************** //
	
	if ($action == "subscribe" && is_email($addr) && post_notification_check_captcha()) {
		$query = $wpdb->get_results(
			"SELECT * " .
			"FROM $t_emails ".
			"WHERE email_addr = '$addr'");
		$query = $query[0];
		if ($query->email_addr == $addr && $query->gets_mail == 1) {
			echo '<h2>' . $post_notification_strings['error'] . '</h2><div class="' . $class . '">' . 
					$post_notification_strings['already_subscribed'] . '</div>';
		} else {
		
			if ($query->email_addr != $addr) {
				mt_srand((double) microtime() * 1000000);
				$key = md5(mt_rand(100000, 99999999) . time());
				$wpdb->query(
					"INSERT INTO $t_emails (email_addr,date_subscribed, act_code) ".
					"VALUES ('" . $wpdb->escape($addr) . "',now(), '$key')");
			} else {
				$key = $query->act_code;
			}
		
			$confurl = $pnurl;
			if(strpos($confurl, '/?')) $confurl .= '&';
			else 					   $confurl .= '?';
			$confurl .= "action=confirm&addr=$addr&id=$key";
	
			// Build Mail
			$msg = post_notification_ldfile('confirm.tmpl');
			
			$msg = str_replace('@@addr',$addr,$msg);
			$msg = str_replace('@@conf_url',$confurl,$msg);
			
			wp_mail($addr, "$blogname - " . get_option('post_notification_page_name'), $msg, post_notification_header());
			
			//Output Page
			echo post_notification_ldfile('reg_success.tmpl');
			
		}
	}
	
	// ******************************************************** //
	//                      CONFIRM
	// ******************************************************** //
	
	elseif ($action == "confirm") {
		if ($wpdb->get_var("SELECT email_addr FROM $t_emails WHERE email_addr = '$addr' AND act_code = '" . $_GET['id'] . "'")) {
			$wpdb->query("UPDATE $t_emails SET gets_mail = 1 where email_addr = '$addr'");
			
			$msg = post_notification_ldfile('activated.tmpl');
			$msg = str_replace('@@addr', $addr, $msg);
			echo $msg;
		} else {
			echo '<h2>' . $post_notification_strings['activation_faild'] . '</h2><div class="' . $class . '">';
			echo '<p class="error">' . $post_notification_strings['address_not_in_database'] . '<br>';
			echo $post_notification_strings['sign_up_again'] . '</p>';
			echo '</div>';
		}
	}
	
	
	// ******************************************************** //
	//                    UNSUBSCRIBE
	// ******************************************************** //
	elseif ($action == "unsubscribe" AND is_email($addr)) {
		if ($wpdb->get_var("SELECT email_addr FROM $t_emails WHERE email_addr = '$addr'")){
			$wpdb->query("DELETE FROM $t_emails WHERE email_addr = '$addr'");
			$msg = post_notification_ldfile('unsubscribe.tmpl');
			$msg = str_replace(array('@@addr','@@pnurl'), array($addr, $pnurl), $msg);
			wp_mail($addr, "$blogname - " . $post_notification_strings['deaktivated'], $msg, post_notification_header());
		}
		echo '<h2>' . $post_notification_strings['deaktivated']. '</h2><div class="' . $class . '">';
		echo str_replace(array('@@addr', '@@blogname'), array($addr, $blogname),
			$post_notification_strings['no_longer_activated']); 
		echo '</div>';
	}
	
	
	// ********************************************************//
	//                     Subscribe-page
	// ********************************************************//
	
	else {
			echo '<h2>' . get_option('post_notification_page_name')  . '</h2><div class="' . $class . '">';
			if($action == "subscribe"){
				if(!is_email($addr))
					echo '<p class="error">' . $post_notification_strings['check_email'] . '</p>';
				if(!post_notification_check_captcha())
					echo '<p class="error">' . $post_notification_strings['wrong_captcha'] . '</p>';
			}
			$msg = post_notification_ldfile('subscribe.tmpl');
			$msg = str_replace('@@action',post_notification_get_link(),$msg);
			$msg = str_replace('@@addr',$addr,$msg);
			if(get_option('post_notification_captcha') == 0){
				$msg = preg_replace('/<!--capt-->(.*?)<!--cha-->/is', '', $msg); //remove captcha
			} else {
				require_once( 'class.captcha.php' );
				$captcha_code = md5(round(rand(0,40000))); 
				$my_captcha = new captcha($captcha_code, ABSPATH . 'wp-content/plugins/post_notification/_temp');
				$captchaimg= get_option('siteurl') . '/wp-content/plugins/post_notification/_temp/cap_' . $my_captcha->get_pic(get_option('post_notification_captcha')) . '.jpg';
				$msg = str_replace('@@captchaimg',$captchaimg,$msg);
				$msg = str_replace('@@captchacode',$captcha_code,$msg);
				
			}
			echo $msg;
			echo '</div>';
	}
}
?>
