<?php

/*
Plugin Name: Post Notification
Plugin URI: http://xn--strbe-mva.de/post-notification/
Description: Sends an email to all subscribers. See readme or instructions for details.
Author: Moritz Str&uuml;be
Version: 1.1 beta 8
License: GPL
Author URI: http://xn--strbe-mva.de
Min WP Version: 2.0

*/

#------------------------------------------------------
# INFO
#------------------------------------------------------
# This is part of the Post Notification Plugin for 
# Wordpress. Please see the readme.txt for details.
#------------------------------------------------------



/// Add the Admin panel

function post_notification_admin_adder(){ 
	add_management_page('Post Notification','Post Notification', 8, 'post_notification/admin.php', 'post_notification_admin');
}


/// Show the admin panel
function post_notification_admin(){
	include (ABSPATH . "wp-content/plugins/post_notification/admin.php");
	post_notification_admin_page();
}

/// Add the subscribe-page to the meta-information
function post_notification_meta(){
	if(get_option('post_notification_page_meta')){
		$link = post_notification_get_link();
		if($link){
			echo '<li><a href="' . $link. '">' . get_option('post_notification_page_name') . '</a></li>';
		}
	}
}

///Load file from profile and do standard Replacement
function post_notification_ldfile($file){
	$msg = file_get_contents(ABSPATH . 'wp-content/plugins/post_notification/' . get_option('post_notification_profile') . '/' . $file);

	if(function_exists('iconv') && function_exists('mb_detect_encoding')){
		$msg = iconv(mb_detect_encoding($msg, "UTF-8, UTF-7, ISO-8859-1, ASCII, EUC-JP,SJIS, eucJP-win, SJIS-win, JIS, ISO-2022-JP"), 
			get_settings('blog_charset'), $msg); //"auto" doesn't work on quite a few platforms so we have to list encodings.	
	}
	$blogname = get_option('blogname');
	$msg = str_replace('@@blogname',$blogname,$msg);
	$msg = str_replace('@@site',$blogname,$msg); 
	
	return $msg;
}

function post_notification_sql_posts_to_send(){
	global $wpdb;
	$t_posts = $wpdb->prefix . 'post_notification_posts';
	if(get_option('db_version')< 4772){
		return " FROM $wpdb->posts p, $t_posts el " .
				"WHERE( ".
				"el.notification_sent >= 0 AND " .
				"p.id = el.post_id AND " .
				"p.post_status IN('publish', 'static' , 'private'))";
	} else {
		return " FROM $wpdb->posts p, $t_posts el " .
			"WHERE( ".
			"el.notification_sent >= 0 AND " .
			"p.id = el.post_id AND " .
			"p.post_status IN('publish', 'private'))";
	}

}

function post_notification_get_link(){
	$page = get_option('post_notification_url');
	if(is_numeric($page)) return _get_page_link($page);
	return $page;
}

/// Calculate when the next mail need to be sent.
function post_notification_set_next_send(){
	global $wpdb;
	
	if(get_option('post_notification_send_private') == 'yes') $private = ", 'private'";
	$d_next = $wpdb->get_var("SELECT MIN(post_date_gmt) " .post_notification_sql_posts_to_send());
	if($d_next){
		$d_next = gmmktime(substr($d_next ,11,2),substr($d_next ,14,2),substr($d_next ,17,2),substr($d_next ,5,2),substr($d_next ,8,2),substr($d_next ,0,4));
		$nervous = get_option('post_notification_lastpost') + get_option('post_notification_nervous'); //There is no other way :-(
		$nextsend = get_option('post_notification_lastsend') + get_option('post_notification_pause');
		
		$d_next = max($d_next, $nextsend, $nervous);
		update_option('post_notification_nextsend', $d_next);
	} else {
		//There are no post with unsent mail.
		update_option('post_notification_nextsend', -1);
	}

}


/// Encode umlauts
function post_notification_encode($in_str, $charset) {
	//$out_str = $in_str;
	$end = '?=';
	$start = '=?' . $charset . '?B?';
	for($i=0; $i < strlen($in_str); $i++){
		if(!mb_check_encoding($in_str[$i], "ASCII")){
			$code .= $in_str[$i];
		} else {
			if($code){
				$out_str .= $start . base64_encode($code) . $end;
				$code = '';
			}
			$out_str .= $in_str[$i];
		}
	}	
	return $out_str;
}


/// Add the option to whether to send a notification
function post_notification_form() {
	global $post_ID, $post, $wpdb;
	$t_posts = $wpdb->prefix . 'post_notification_posts';
	
	load_plugin_textdomain('post_notification','wp-content/plugins/post_notification/');
	
	$textyes = __('Yes', 'post_notification');
	$default = false;
	
	if(0 != $post_ID){ //We've got an ID.
		$status= $wpdb->get_var("SELECT notification_sent FROM $t_posts WHERE post_ID = '$post_ID'");

		if(isset($status)){ //It's in the DB
			if($status == 0){ //It will be sent in the future
				$sendY = 'selected="selected"';
			} else { //It has been sent or is being sent.
				$sendN = 'selected="selected"';
				if($status != -2){ //If it's -2 nothing has been sent.
					$textyes = __('Resend', 'post_notification');
				}
			}
		} else { //It's not in the DB
			if($post->post_status = 'published'){ //This one has been bulished but no mail sent
				$sendN = 'selected="selected"';
			} else {
				$default = true;
			}
		}
	} else {
		$default = true;
	}
	
	?>
	<div id="advancedstuff" class="dbx-group">
		<div class="dbx-b-ox-wrapper">
			<fieldset id="emailnotification" class="dbx-box">
			<div class="dbx-h-andle-wrapper"><h3 class="dbx-handle">Newsletter</h3></div>
				<div class="dbx-c-ontent-wrapper">
					<div class="dbx-content"><? _e('Send notification when publishing?', 'post_notification'); ?>
						<select id="post_notification_notify" name="post_notification_notify" />
							<?php if($default){?>
								<option value="def" selected="selected"><?php _e('Default', 'post_notification')  ?></option>
							<?php } ?>
							<option value="yes" <? echo $sendY; ?>><?php echo $textyes;  ?></option>
							<option value="no"  <? echo $sendN; ?>><?php _e('No', 'post_notification') ?></option>
						</select>
					</div>
				</div>
			</fieldset>
	</div>
	<?php
}


/// Add a Post to the notificationlist
function post_notification_add($post_ID)  {
	global $wpdb;  
	$post = get_post($post_ID);
	
	$t_posts = $wpdb->prefix . 'post_notification_posts'; 
	$notify    = $_POST['post_notification_notify'];

	//let's see what's default
	if($notify == 'def'){
		if(get_option('db_version')< 4772){
			if($post->post_status == 'post')			$notify = get_option('post_notification_send_default');
			if($post->post_status == 'private')	$notify = get_option('post_notification_send_default');
			if($post->post_status == 'static')			$notify = get_option('post_notification_send_page');
		} else {
			if($post->post_type == 'post')			$notify = get_option('post_notification_send_default');
			if($post->post_type == 'post' 
			  && $post->post_status == 'private')	$notify = get_option('post_notification_send_default');
			if($post->post_type == 'page')			$notify = get_option('post_notification_send_page');
		} 
	}
	
	
	$status = $wpdb->get_var("SELECT notification_sent FROM $t_posts WHERE post_ID = '$post_ID'");
	if($notify == 'yes'){
		if(isset($status)) $wpdb->query("UPDATE $t_posts  SET notification_sent = 0 WHERE post_id = " . $post_ID  );
		else $wpdb->query("INSERT INTO $t_posts  (post_ID, notification_sent) VALUES ('$post_ID',  0)");
	} else {
		if($status != -1){ //Mails are sent - ne reason to change this
			if(isset($status)) $wpdb->query("UPDATE $t_posts  SET notification_sent = -2 WHERE post_id = " . $post_ID  );
			else $wpdb->query("INSERT INTO $t_posts  (post_ID, notification_sent) VALUES ('$post_ID',  -2)");
		}
	}
	// This really sucks, as all Mails are blocked, but WP doesn't use the modification-attributs for posts anymore. :-(
	update_option('post_notification_lastpost', time());
	post_notification_set_next_send(); 
}

function post_notification_header($html = false){
	if(get_option('post_notification_hdr_nl') == 'rn')
		$hdr_nl = "\r\n";
	else
		$hdr_nl = "\n";
	
	$header  = "MIME-Version: 1.0$hdr_nl";
		
	if ($html){
		$header .= 'Content-Type: text/html; charset="' . get_settings('blog_charset') . '"' . $hdr_nl;
	} else {
		$header .= 'Content-Type: text/plain; charset="' . get_settings('blog_charset') . '"' . $hdr_nl;
	}

	$from_name = str_replace('@@blogname',get_option('blogname'),get_option('post_notification_from_name'));
	if(function_exists('mb_check_encoding')){
		if(!mb_check_encoding($from_name, "ASCII")) $from_name = post_notification_encode($from_name, get_settings('blog_charset') );
	}
	$from_email    = get_option('post_notification_from_email');
	
	$header .= "From: \"$from_name\" <$from_email>$hdr_nl";
	$header .= "Reply-To: $from_email$hdr_nl";
	$header .= "Return-Path: $from_email$hdr_nl";
	return $header;
}


/// Send mails.
function post_notification_send() {
	global $wpdb;  

	if(get_option('post_notification_nextsend') == -1) return;
	if(get_option('post_notification_nextsend') > time()) return; //There's nothing to send.
	

	$mutex = @fopen(ABSPATH . 'wp-content/plugins/post_notification/_temp/post_notification.lock', 'w');
	
	if ( !$mutex || !flock($mutex, LOCK_EX|LOCK_NB, $eWouldBlock) || $eWouldBlock ) {
		// There is already someone mailing. 
		@fclose($mutex);
		return;
	}
	wp_cache_close(); //We need to shut, so another pageview can be rendered while sending mails.

	$t_emails = $wpdb->prefix . 'post_notification_emails';
	$t_posts = $wpdb->prefix . 'post_notification_posts';

	
	//Get the date
	//Unfortunately current_time can't be used.
	$curr_date = gmdate('Y-m-d H:i:s', (time() + get_option('post_notification_nervous'))); 
	
	$posts = $wpdb->get_results("SELECT * " . post_notification_sql_posts_to_send());
	
	if(!$posts){ //This shouldn't happen, but never mind.
		post_notification_set_next_send();
		return; //Nothing to do.
	}

	//Ok. Here the fun begins.
	
	$blogname = get_option('blogname');
	
	if(get_option('post_notification_hdr_nl') == rn)
		$hdr_nl = "\r\n";
	else
		$hdr_nl = "\n";
	
	$template = (get_option('post_notification_template'));
	if(substr($template, -5) == '.html'){ 
		$html_email = true; 
	} else {
		$html_email = false;
	}

	
	# Mail out mails
	$maxsend = get_option('post_notification_maxsend');
	$mailssent = -1;
	
	foreach($posts as $post) {	
		$post_url = _get_page_link($post->ID);
		
		$post_author = stripslashes($post->post_author);			
		$post_title = stripslashes($post->post_title);
		if(get_option('post_notification_show_content') == 'yes'){
			$post_content = stripslashes($post->post_content);
		}else if(get_option('post_notification_show_content') == 'more'){
			$post_content = stripslashes($post->post_content);
			list($post_content, $more_content) = split('<!--more', $post_content);
			if($more_content){
				$post_content .= '<a href="@@permalink" >'. get_option('post_notification_read_more') . '</a>' ;
			}
		}else if(get_option('post_notification_show_content') == 'excerpt'){
			$post_content = stripslashes($post->post_excerpt);
			$post_content .= '<br /><a href="@@permalink" >'. get_option('post_notification_read_more') . '</a>' ;
		}
		
		
		if($post_content){
			if(!$html_email){
				remove_filter('the_content', 'convert_smilies' ); //We defenetly don't want smilie - Imgs in Text-Mails.
			}
			$post_content = apply_filters('the_content', $post_content);
		}
		
		// Do some datestuff
		$post_date = mysql2date(get_settings('date_format'), $post->post_date);
		$post_time = mysql2date(get_settings('time_format'), $post->post_date);		
		if(!$html_email){
			$post_time = @html_entity_decode($post_time,ENT_QUOTES,get_settings('blog_charset'));
			$post_date = @html_entity_decode($post_date,ENT_QUOTES,get_settings('blog_charset'));
			
			if(function_exists('iconv') && (strpos(phpversion(), '4') == 0)){ //html_entity_decode does not support UTF-8 in php < 5
				$post_time = iconv('ISO8859-1', get_settings('blog_charset'), $post_time);
				$post_date = iconv('ISO8859-1', get_settings('blog_charset'), $post_date);
			}
		}

		$post_title = strip_tags($post_title);
		
	
		//Convert from HTML to text.
		if (!$html_email && isset($post_content)){
			require_once('class.html2text.php');
			$h2t =& new html2text($post_content);
			$post_content = $h2t->get_text();
		}
		
		// Load template
		$msg = post_notification_ldfile($template);
		
		
		// Replace variables						
		$msg = str_replace('@@content',$post_content,$msg); //Insert the posting first. -> for Replacements
		$msg = str_replace('@@title',$post_title,$msg);
		$msg = str_replace('@@permalink',$post_url,$msg);
		$msg = str_replace('@@author',$post_author,$msg);
		$msg = str_replace('@@time',$post_time,$msg);
		$msg = str_replace('@@date',$post_date,$msg);
		
		$unsub = post_notification_get_link();
		if(strpos($unsub, '/?')) $unsub .= '&';
		else 					$unsub .= '?';
		$unsub .= 'action=unsub&addr=@@addr';
		$msg = str_replace('@@unsub', $unsub, $msg);
		
		// EMAIL HEADER 
		$header  = post_notification_header($html_email);
			
		
		// SUBJECT 
		$subject = get_option('post_notification_subject');
		$subject = str_replace('@@blogname',$blogname, $subject);
		if ($post_title != ''){
			$subject = str_replace('@@title', $post_title, $subject);
		} else {
			$subject = str_replace('@@title', __('New post', 'post_notification'), $subject);
		}
		if(function_exists('mb_check_encoding')){
			if(!mb_check_encoding($subject, "ASCII")) $subject = post_notification_encode($subject, get_settings('blog_charset') );		
		}
		# Email the post
		$emails = $wpdb->get_results(
			" SELECT email_addr, id " .
			" FROM $t_emails ".
			" WHERE gets_mail = 1 AND id >= " . $post->notification_sent . //Only send to people who havn't got mail before.
			" ORDER BY id ASC"); //We need this. Otherwise we can't be shure whether we already have sent mail.
		
		
		if($emails){ //Check wheater ther are any mails to send anything.
			foreach ($emails as $email) {
				if($maxsend < 1){ //Are we allowed to send any more mails?
					$mailssent = $email->id; //Save where we stoped
					break;
				}
				$msgFinal = str_replace('@@addr',$email->email_addr,$msg);
				wp_mail($email->email_addr, $subject, $msgFinal, $header);
				$maxsend--;
			}
		}
		// Update notification_sent to -1 (We're done)
		$wpdb->query(	
			" UPDATE $t_posts " .
			" SET " .
			" notification_sent = " . $mailssent .
			" WHERE post_id = " . $post->ID  );
		

		if($maxsend < 1) break; //We dont need to go on, if there's nothing to send.
	}
	update_option('post_notification_lastsend', time());
	post_notification_set_next_send();
	flock($mutex, LOCK_UN);
	fclose($mutex);
}

function post_notification_installtheme(){
	$src  = ABSPATH . 'wp-content/plugins/post_notification/post_notification_template.php';
	$dest = ABSPATH . 'wp-content/themes/' . get_option('template') . '/post_notification_template.php';
	if(!@file_exists($dest)){
		if(!@copy($src,$dest)){
			return $dest;
		}
	}
	return '';
}



//install stuf
function post_notification_install(){
	global $wpdb;
	$t_emails = $wpdb->prefix . 'post_notification_emails';
	$t_posts = $wpdb->prefix . 'post_notification_posts';
	
	
	//******************************************//
	//**  Create WPPRAEFIX_post_notification table   **// 
	//******************************************//
	require_once(ABSPATH . 'wp-admin/upgrade-functions.php');
	
	if($wpdb->get_var("show tables like '$t_emails'") != $t_emails){
		$sql = "CREATE TABLE $t_emails (
					  id int( 11 ) NOT NULL auto_increment,
					  email_addr varchar( 255 ) default NULL,
					  gets_mail int( 11 ) default NULL,
					  last_modified timestamp( 14 ) NOT NULL,
					  date_subscribed datetime default NULL,
					  act_code varchar( 32 ) default NULL,
					  PRIMARY KEY  ( id )   
			   )";
		
		dbDelta($sql);
	}
	

	
	//************************************************//
	//**  Create WPPRAEFIX_post_notification_posts table **// 
	//************************************************//
	if($wpdb->get_var("show tables like '$t_posts'") != $t_posts){
	
		# Add new table
		$sql = "CREATE TABLE $t_posts (
						post_id bigint(20) NOT NULL default '0',
						notification_sent int NOT NULL default '-1',
						PRIMARY KEY  (post_ID)
			   )"; 
			   
		dbDelta($sql);
	}
	//************************************************//
	//**         Add Options
	//************************************************//
	load_plugin_textdomain('post_notification','wp-content/plugins/post_notification/');
	
	add_option('post_notification_show_content', 'no', 'Whether to mail the content', 'no');
	add_option('post_notification_read_more', '...', 'What to put in more-tag-text', 'no');
	add_option('post_notification_send_default', 'no', 'Whether to send private posts', 'no');
	add_option('post_notification_send_private', 'no', 'Whether to send private posts', 'no');
	add_option('post_notification_send_page', 'no', 'Whether to send private posts', 'no');
	add_option('post_notification_hdr_nl', "n", 'What kind of header', 'no'); 
	add_option('post_notification_from_email', get_option('admin_email'), 'The adress used as sender', 'no');
	add_option('post_notification_from_name', '@@blogname', 'The name used as sender', 'no');
	add_option('post_notification_subject', '@@blogname: @@title', 'The subject of the mail', 'no');
	/// \todo Maby it makes sense to just add the filename
	add_option('post_notification_url', '', 'The URl to the main page', 'no');
	add_option('post_notification_template', "email_template.txt", 'The Template to use', 'no');
	add_option('post_notification_maxsend', "20" , 'Number of Mails to send at once.', 'no');
	add_option('post_notification_pause', "10" , 'Time between bursts of Mails', 'no');
	add_option('post_notification_nervous', "360", 'Nervous finger option');
	add_option('post_notification_nextsend', time(), 'When to send the next mail', 'yes');
	add_option('post_notification_lastsend', time(),  'When to send the last mail was sent.', 'no');
	add_option('post_notification_lastpost', time(),  'When the last post was published.', 'no');
	add_option('post_notification_page_meta', flase , 'Whether to add a link to Meta', 'yes');
	//autoload is set to yes, because meta might need it.
	add_option('post_notification_page_name', __('Subscribe to Posts', 'post_notification') ,'Name of the Post Notification page.', 'yes');
	add_option('post_notification_uninstall', false ,'Uninstall on deaktivation', 'no');
	add_option('post_notification_captcha', '0','Number of captcha-cahars', 'no');
	
	
	if(is_dir(ABSPATH . 'wp-content/plugins/post_notification/' . WPLANG))
		$profile = WPLANG;
	else
		$profile = 'en_US';
	add_option('post_notification_profile', $profile, 'The Profile-dir to use'); 
}

function post_notification_uninstall(){
	global $wpdb;
	
	$t_emails = $wpdb->prefix . 'post_notification_emails';
	$t_posts = $wpdb->prefix . 'post_notification_posts';
	
	if(!get_option('post_notification_uninstall')) return; //We do not want to delte anything.
	
	//
	$wpdb->query("DROP TABLE $t_emails");
	$wpdb->query("DROP TABLE $t_posts");
	
	//delete all options
	$wpdb->query("DELETE FROM $wpdb->options WHERE option_name LIKE 'post_notification%'");
}


//********************************************//
// Actions
//********************************************//

// Notify box in advanced mode
add_action('edit_form_advanced', 'post_notification_form', 5);

// Notify box in simple mode
add_action('simple_edit_form', 'post_notification_form', 5);

// Notify box in page mode
add_action('edit_page_form', 'post_notification_form', 5);

// Admin menu
add_action('admin_menu', 'post_notification_admin_adder');


// Save for notification
add_action('save_post', 'post_notification_add', 5);

// Send the notification
add_action('shutdown', 'post_notification_send');
//add_action('admin_footer', 'post_notification_send');

// Trigger installation
add_action('activate_post_notification/post_notification.php','post_notification_install');

// Trigger uninstallation
add_action('deactivate_post_notification/post_notification.php','post_notification_uninstall');

// Add Metainformation
add_action('wp_meta', 'post_notification_meta', 0); 

// Copy template to theme
add_action('switch_theme', 'post_notification_installtheme');

?>
